<?php

namespace Myquest\Controller;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DataSource\DataSet;

class ReservationManagmentController
{
  protected $entityManager;

  public function __construct($environment, $entityManager)
  {
    $this->environment = $environment;
    $this->entityManager = $entityManager;
  }

  public function getManagementReservationsById($request, $response)
  {
    $row = $request->getRow();
    try {
      $sql = "SELECT NRRESERVA, NMUSUARIO, SETOR, CDFILIAL, CDSERVFILI, NMSERVICO, DTCARDAPIO, HRCONSUMO, IDSTATUSRESERVA, TIPORESERVA, CDREGISTROPESSOA FROM(SELECT TO_CHAR('_'||( XMLAGG( XMLELEMENT(E, AP.NRAVALIACAOPRATO, '_')).EXTRACT('//text()').GETCLOBVAL())) AS NRRESERVA, MAX(NMUSUARIO) AS NMUSUARIO, MAX(DSCONSUMO) AS SETOR, AP.CDFILIAL, AP.CDSERVFILI, NVL(S.NMFANTASSERV, S.NMSERVICO) AS NMSERVICO, AP.DTCARDAPIO, AP.HRCONSUMO, AP.IDSTATUSRESERVA, 'PRATOS' AS TIPORESERVA, AP.CDREGISTROPESSOA, COUNT(*) AS QTDE FROM AVALIACAOPRATO AP INNER JOIN SERVICO S ON AP.CDFILIAL = S.CDFILIAL AND AP.CDSERVFILI = S.CDSERVFILI WHERE AP.CDFILIAL = :CDFILIAL AND NVL(AP.NRLOCALPESQ, -1) = NVL(:NRLOCALPESQ, -1) AND AP.DTCARDAPIO = :DTCARDAPIO AND AP.NRORG = :NRORG AND((INSTR(:IDSTATUSRESERVA, AP.IDSTATUSRESERVA) <> 0) OR (:IDSTATUSRESERVA = 'TODOS' AND AP.IDSTATUSRESERVA IS NOT NULL)) AND (CDREGISTROPESSOA = :CDREGISTROPESSOA OR :CDREGISTROPESSOA IS NULL) GROUP BY AP.CDFILIAL, AP.CDSERVFILI, NVL(S.NMFANTASSERV, S.NMSERVICO), AP.DTCARDAPIO, AP.HRCONSUMO, AP.IDSTATUSRESERVA, AP.CDREGISTROPESSOA UNION ALL SELECT TO_CHAR(NRAVALIACAOSERVICO) AS NRRESERVA, NMUSUARIO, DSCONSUMO AS SETOR, AV.CDFILIAL, AV.CDSERVFILI, NVL(S.NMFANTASSERV, S.NMSERVICO) AS NMSERVICO, AV.DTCARDAPIO, AV.HRCONSUMO, AV.IDSTATUSRESERVA, 'SERVICOS' AS TIPORESERVA, AV.CDREGISTROPESSOA, 1 AS QTDE FROM AVALIACAOSERVICO AV INNER JOIN SERVICO S ON AV.CDFILIAL = S.CDFILIAL AND AV.CDSERVFILI = S.CDSERVFILI WHERE AV.CDFILIAL = :CDFILIAL AND NVL(AV.NRLOCALPESQ, -1) = NVL(:NRLOCALPESQ, -1) AND AV.DTCARDAPIO = :DTCARDAPIO AND AV.NRORG = :NRORG AND ((INSTR(:IDSTATUSRESERVA, AV.IDSTATUSRESERVA) <> 0) OR (:IDSTATUSRESERVA = 'TODOS' AND AV.IDSTATUSRESERVA IS NOT NULL)) AND (CDREGISTROPESSOA = :CDREGISTROPESSOA OR :CDREGISTROPESSOA IS NULL)) ORDER BY DTCARDAPIO, HRCONSUMO, TIPORESERVA";
      $conn = $this->entityManager->getConnection();
      $params = [
        'NRORG'            => $row['nrorg'],
        'IDSTATUSRESERVA'  => $row['status'],
        'DTCARDAPIO'       => $row['dt_cardapio'],
        'CDREGISTROPESSOA' => $row['cpf'],
        'CDFILIAL'         => $row['cdfilial'],
        'NRLOCALPESQ'         => $row['nrlocalpesq'],        
      ];
      $statement = $conn->prepare($sql);
      $statement->execute($params);
      $result = $statement->fetchAll();
      $response->addDataSet(new DataSet('userReservations', $result));
    } catch (Exception $e) {
      throw $e;
    }
  }

  public function getManagementReservationData($request, $response)
  {
    $row = $request->getRow();
    $conn = $this->entityManager->getConnection();

    try {
      $sqlPlate = "SELECT AP.NRAVALIACAOPRATO, AP.NMUSUARIO, AP.DSCONSUMO, AP.IDSTATUSRESERVA, AP.DTCARDAPIO, AP.HRCONSUMO, 'PRATOS' AS TIPORESERVA, P.NMPRATO FROM AVALIACAOPRATO AP INNER JOIN PRATO P ON AP.CDFILAUXPRAT = P.CDFILAUXPRAT AND AP.CDPRATO = P.CDPRATO WHERE AP.CDFILIAL = :CDFILIAL AND AP.CDSERVFILI = :CDSERVFILI AND AP.DTCARDAPIO = :DTCARDAPIO AND AP.HRCONSUMO = :HRCONSUMO AND AP.CDREGISTROPESSOA = :CDREGISTROPESSOA";
      $sqlService = "SELECT AV.NRAVALIACAOSERVICO, AV.NMUSUARIO, AV.DSCONSUMO, AV.IDSTATUSRESERVA, AV.DTCARDAPIO, AV.HRCONSUMO, 'SERVICOS' AS TIPORESERVA, :NMSERVICO FROM AVALIACAOSERVICO AV WHERE NRAVALIACAOSERVICO = :NRRESERVA";

      $paramsPlate = ['DTCARDAPIO' => $row['DTCARDAPIO'], 'CDSERVFILI' => $row['CDSERVFILI'], 'CDFILIAL' => $row['CDFILIAL'], 'HRCONSUMO' => $row['HRCONSUMO'], 'CDREGISTROPESSOA' => $row['CDREGISTROPESSOA']];
      $paramsService = ['NMSERVICO' => $row['NMSERVICO'], 'NRRESERVA' => $row['NRRESERVA']];

      $sql = $row['TIPORESERVA'] == 'SERVICOS' ? $sqlService : $sqlPlate;
      $params = $row['TIPORESERVA'] == 'SERVICOS' ? $paramsService : $paramsPlate;

      $statement = $conn->prepare($sql);
      $statement->execute($params);
      $result = $statement->fetchAll();
      $response->addDataSet(new DataSet('reservationData', $result));
    } catch (Exception $e) {
      throw $e;
    }
  }

  public function managementReservationCheckout($request, $response)
  {
    $row = $request->getRow();
    $conn = $this->entityManager->getConnection();

    try {
      $sqlPlate = "UPDATE AVALIACAOPRATO SET IDSTATUSRESERVA = :STATUS WHERE INSTR(:NRAVALIACAOPRATO, '_'|| NRAVALIACAOPRATO ||'_') <> 0";
      $sqlService = 'UPDATE AVALIACAOSERVICO SET IDSTATUSRESERVA = :STATUS WHERE NRAVALIACAOSERVICO = :NRAVALIACAOSERVICO';

      $paramsPlate = ['STATUS' => $row['STATUS'], 'NRAVALIACAOPRATO' => '_' . implode('_', $row['NRAVALIACAOPRATO']) . '_'];
      $paramsService = ['STATUS' => $row['STATUS'], 'NRAVALIACAOSERVICO' => $row['NRRESERVA']];

      $sql = $row['TIPORESERVA'] == 'SERVICOS' ? $sqlService : $sqlPlate;
      $params = $row['TIPORESERVA'] == 'SERVICOS' ? $paramsService : $paramsPlate;

      $statement = $conn->prepare($sql);
      $statement->execute($params);
    } catch (Exception $e) {
      throw $e;
    }
  }
}
